#include <GL/glew.h>
#include <QImage.h>
#include <QGL.h>
#include <vcg/Point3.h>
#include <QString.h>
#include <QTextStream.h>
#include "MMGrid.h"

using namespace std;
using namespace vcg;

void MMGrid::drawGL()
{
	glPushMatrix();
	scalefactor=2.0f/max(sx,sy);
	glRotatef(-90,1,0,0);
	glTranslatef(-1.0f,-1.0f,0);
	glScalef(scalefactor,scalefactor,scalefactor);
	/*if(ti) 
	{
	  glEnable(GL_TEXTURE_2D);
	  glBindTexture(GL_TEXTURE_2D,ti);
	}*/
	vector<MMCell>::iterator ci;
	glGetDoublev(GL_MODELVIEW_MATRIX,mm); 
	glGetDoublev(GL_PROJECTION_MATRIX,mp); 
	glGetIntegerv(GL_VIEWPORT,vp);
	int contite=0;
	for(ci=g.begin();ci!=g.end();++ci)
	{
		if(tex[contite]) 
		{
			glEnable(GL_TEXTURE_2D);
			//glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_CLAMP);
			glBindTexture(GL_TEXTURE_2D,tex[contite]);
		}

		//if(finishgrid[contite]) {
		if((*ci).finish) {
			glColor3f(0,1,0);
			(*ci).drawGL();
			glColor3f(1,1,1);
		}
		else {
			glColor3f(1,1,1);
			(*ci).drawGL();
		}
		if(tilati) 
		{
			glEnable(GL_TEXTURE_2D);
			//glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);
			glBindTexture(GL_TEXTURE_2D,tilati);
		}

		(*ci).drawGL2();
		contite++;
	}
	glColor3f(1,1,1);
	if(tisphere) 
	{
		glEnable(GL_TEXTURE_2D);

		//glTexGeni(GL_S, GL_TEXTURE_GEN_MODE, GL_SPHERE_MAP);
		//glTexGeni(GL_T, GL_TEXTURE_GEN_MODE, GL_SPHERE_MAP);
		//glEnable(GL_TEXTURE_GEN_S);
		//glEnable(GL_TEXTURE_GEN_T);
				glBindTexture(GL_TEXTURE_2D,tisphere);


		//float planevs[4]={1.0f,0,0,0};
		//float planevt[4]={0,1.0f,0,0};
		//glTexGenfv(GL_S,GL_OBJECT_PLANE,planevs);
		//glTexGenfv(GL_T,GL_OBJECT_PLANE,planevt);
	}

	sp.pause=pause;
    sp.drawGL();
	//glDisable(GL_TEXTURE_GEN_S);
	//glDisable(GL_TEXTURE_GEN_T);

	start.drawGL();
	bumper.drawGL();
	//finish.drawGL();
	glPopMatrix();
}


bool MMGrid::pickGL(Point2i in, Point2i &pos)
{
	float z;
	glReadPixels(in[0],vp[3]-in[1],1,1,GL_DEPTH_COMPONENT ,GL_FLOAT,&z);
	return pickGL(Point3d(in[0],vp[3]-in[1],z),pos);
}

bool MMGrid::pickGL(Point3d in, Point2i &pos)
{
	Point3d o;
	gluUnProject(in[0],in[1],in[2],mm,mp,vp,&o[0],&o[1],&o[2]);
 	qDebug("picked %f %f %f\n",o[0],o[1],o[2]);
	if(o[0]<0 || o[0]>sx ) return false;
	if(o[1]<0 || o[1]>sy ) return false;
	pos[0]=o[0];
	pos[1]=o[1]; 
	
	return true;
}

void MMGrid::resize(const int _sx, const int _sy) 
{
	sx=_sx; sy=_sy;
	g.resize(sx*sy);
	bumper.exist = false;
	int i,j;
	for(i=0;i<sx;++i)
		for(j=0;j<sy;++j)
		{
			G(i,j).V[0]=Point3f(i+0,j+0,0);
			G(i,j).V[1]=Point3f(i+1,j+0,0);
			G(i,j).V[2]=Point3f(i+1,j+1,0);
			G(i,j).V[3]=Point3f(i+0,j+1,0);
			G(i,j).texFileName="data/tile.png";
			G(i,j).ComputeNormal();
			G(i,j).selected=false;
			G(i,j).ice=false;

		}
	generateFace();
	lateraltexFileName="data/tile.png";
	for (int fff=0;fff<1000;fff++) {
		finishgrid[fff]=false;
	}
	initGL();

}
// in una cella
// 
//  v3  v2
//   
//  v0  v1 
//

void MMCell::drawGL()
{
	if(selected) glColor3f(1,0,0);
	//else glColor3f(1,1,1);

    
	 
	glBegin(GL_QUADS);
	glNormal(n);
	glTexCoord2f(0.0f,0.0f);
	glVertex(V[0]);
	glTexCoord2f(1.0f,0.0f);
	glVertex(V[1]);
	glTexCoord2f(1.0f,1.0f);
	glVertex(V[2]);
	glTexCoord2f(0.0f,1.0f);
	glVertex(V[3]);
	glEnd();
}

void MMCell::drawGL2()
{
	
	

glBegin(GL_QUADS);

if (B3[0]) {
	/*
	glNormal3f(0,-1,0);
	glTexCoord2f(0.05f,0.05f);
	glVertex  (V[0]);
	glTexCoord2f(1.95f,0.05f);
	glVertex3f(V[0][0], V[0][1], B1[0]);
	glTexCoord2f(1.95f,0.95f);
	glVertex3f(V[1][0], V[1][1], B2[1]);
	glTexCoord2f(0.05f,0.95f);
	glVertex  (V[1]);
	*/
	glNormal3f(0,-1,0);

	glTexCoord2f(0.0f,0.0f);
	glVertex  (V[0]);

	glTexCoord2f(fabs(B1[0]-V[0][2]),0.0f);
	glVertex3f(V[0][0], V[0][1], B1[0]);

	glTexCoord2f(fabs(B2[1]-V[1][2]),1.0f);
	glVertex3f(V[1][0], V[1][1], B2[1]);

	glTexCoord2f(0.0f,1.0f);
	glVertex  (V[1]);
}
	
if (B3[1]) {
  glNormal3f(1,0,0);
  glTexCoord2f(0.0f,0.0f);
	glVertex  (V[1]);
	glTexCoord2f(fabs(B1[1]-V[1][2]),0.0f);
	glVertex3f(V[1][0], V[1][1], B1[1]);
	glTexCoord2f(fabs(B2[2]-V[2][2]),1.0f);
	glVertex3f(V[2][0], V[2][1], B2[2]);
	glTexCoord2f(0.0f,1.0f);
	glVertex  (V[2]);
}

if (B3[2]) {
	glNormal3f(0,1,0);
	glTexCoord2f(0.0f,0.0f);
	glVertex  (V[2]);
	glTexCoord2f(fabs(B1[2]-V[2][2]),0.0f);
	glVertex3f(V[2][0], V[2][1], B1[2]);
	glTexCoord2f(fabs(B2[3]-V[3][2]),1.0f);
	glVertex3f(V[3][0], V[3][1], B2[3]);
	glTexCoord2f(0.0f,1.0f);
	glVertex  (V[3]);
}

if (B3[3]) {
	glNormal3f(-1,0,0);
	glTexCoord2f(0.0f,0.0f);
	glVertex  (V[3]);
	glTexCoord2f(fabs(B1[3]-V[3][2]),0.0f);
	glVertex3f(V[3][0], V[3][1], B1[3]);
	glTexCoord2f(fabs(B2[0]-V[0][2]),1.0f);
	glVertex3f(V[0][0], V[0][1], B2[0]);
	glTexCoord2f(0.0f,1.0f);
	glVertex  (V[0]);
}

	glEnd();

}

void MMCell::ComputeNormal()
{
	Point3f e01=V[1]-V[0];
	Point3f e02=V[2]-V[0];
	n=e01^e02;
	n.Normalize();
}

void MMGrid::initGL()
{
		glEnable(GL_TEXTURE_2D);
		glGenTextures(sx*sy, tex);
		int contite=0;
		vector<MMCell>::iterator ii;
		for (ii=g.begin();ii!=g.end();++ii) {
			QImage tt; 	tt.load((*ii).texFileName);
			QImage tx = QGLWidget::convertToGLFormat ( tt);
			glBindTexture(GL_TEXTURE_2D, tex[contite]);
			gluBuild2DMipmaps(GL_TEXTURE_2D, 3, tx.width(), tx.height(), GL_RGBA, GL_UNSIGNED_BYTE, tx.bits() );
			contite++;
		}




		/*QImage tt; 	tt.load(texFileName);
		QImage tx = QGLWidget::convertToGLFormat ( tt);
		glBindTexture(GL_TEXTURE_2D, ti);
		gluBuild2DMipmaps(GL_TEXTURE_2D, 3, tx.width(), tx.height(), GL_RGBA, GL_UNSIGNED_BYTE, tx.bits() );*/
		glGenTextures(1, &tilati);
		QImage ttlati; 	ttlati.load(lateraltexFileName);
		QImage txlati = QGLWidget::convertToGLFormat ( ttlati);
		glBindTexture(GL_TEXTURE_2D, tilati);
		gluBuild2DMipmaps(GL_TEXTURE_2D, 3, txlati.width(), txlati.height(), GL_RGBA, GL_UNSIGNED_BYTE, txlati.bits() );

		glGenTextures(1, &tisphere);
		QImage ttsphere; 	ttsphere.load("data/sphere.png");
		QImage txsphere = QGLWidget::convertToGLFormat ( ttsphere);
		glBindTexture(GL_TEXTURE_2D, tisphere);
		gluBuild2DMipmaps(GL_TEXTURE_2D, 3, txsphere.width(), txsphere.height(), GL_RGBA, GL_UNSIGNED_BYTE, txsphere.bits() );
}

void MMGrid::clearSelection()
{
	vector<MMCell>::iterator ii;
	for (ii=g.begin();ii!=g.end();++ii) (*ii).selected=false;
 }

void MMGrid::selectRect(Point2i s, Point2i e)
{
	int i,j;
	if(s[0]>e[0]) swap(s[0],e[0]);
	if(s[1]>e[1]) swap(s[1],e[1]);
	for(i=s[0];i<=e[0];++i)
		for(j=s[1];j<=e[1];++j)
			G(i,j).selected=true;	
}

void MMGrid::setTexture(QString t) {
	vector<MMCell>::iterator ii;
	for (ii=g.begin();ii!=g.end();++ii) 
		if((*ii).selected)
			(*ii).setTexture(t);
}

void MMGrid::setIce(bool b) {
	vector<MMCell>::iterator ii;
	for (ii=g.begin();ii!=g.end();++ii) {
		if((*ii).selected) {
			if (!(*ii).glue) {
				if (b) {
					(*ii).setTexture("data/ice.png");
					(*ii).ice=true;
				} else {
					(*ii).setTexture("data/tile.png");
					(*ii).ice=false;
				}
			}

		}
	}
}

void MMGrid::setGlue(bool b) {
	vector<MMCell>::iterator ii;
	for (ii=g.begin();ii!=g.end();++ii) {
		if((*ii).selected) {
			if (!(*ii).ice) {
				if (b) {
					(*ii).setTexture("data/glue.png");
					(*ii).glue=true;
				} else {
					(*ii).setTexture("data/tile.png");
					(*ii).glue=false;
				}
			}

		}
	}
}

void MMGrid::raiseSelected(float f)
{
	vector<MMCell>::iterator ii;
	for (ii=g.begin();ii!=g.end();++ii) 
		if((*ii).selected)
			for(int k=0;k<4;++k)
				(*ii).V[k].z()+=f;

	generateFace();
}

 //  ----- ----- -----
 // | 3 2 | 3 2 | 3 2 | 
 // | 0 1 | 0 1 | 0 1 |
 //  ----- ===== ----- 
 // | 3 2 " 3 2 " 3 2 | 
 // | 0 1 " 0 1 " 0 1 |
 //  ----- ===== ----- 
 // | 3 2 | 3 2 | 3 2 | 
 // | 0 1 | 0 1 | 0 1 |
 //  ----- ----- ----- 

// I vertici di ogni cella sono indiciati come sopra.
//
// L'alg di smooth serve a far si che in una zona selezionata, 
// tutti i vertici che condividono le stesse xy 
// (eccetto quelli sul bordo della zona selezionata)
// abbiano la stessa z (la media delle z medie delle celle coinvolte)
//

void MMGrid::smoothSelected()
{
  // 1) si calcola il valor medio e lo si stora in una var temporanea G(i,j).tmpH[k]
	int bp[4][2]={{ 0, 0},{ 1, 0},{1,1},{ 0,1}}; // base position of each vertex of the cell
	int dp[4][2]={{-1, -1},{ 0, -1 },{0,0},{ -1, 0}}; // delta of the four adj of a cell vertex
	int i,j,k,q;
	int cnt;
	float tH;
	for(i=0;i<sx;++i)
		for(j=0;j<sy;++j)
			if(G(i,j).selected)
				for(k=0;k<4;++k) //for each cell vertex;
				{
					tH=0;
					cnt=0;
					for(q=0;q<4;++q) // foreach adj of a cell vertexe
						{ 
              int adjX=i+dp[k][0]+bp[q][0];
              int adjY=j+dp[k][1]+bp[q][1];

							if(adjX>=0 && adjX<sx && adjY>=0 && adjY<sy) 
                {
                  tH+=G(adjX,adjY).avgH();
							    ++cnt;
               }
						}
					G(i,j).tmpH[k]=tH/cnt;
				}
 // 1) si aggiorna tutti vertici non di bordo
  for(i=0;i<sx;++i)
		for(j=0;j<sy;++j)
			if(G(i,j).selected)
				for(k=0;k<4;++k) 
        {
          bool tt=true;
	        for(q=0;q<4;++q)
          {
            int adjX=i+dp[k][0]+bp[q][0];
            int adjY=j+dp[k][1]+bp[q][1];
            if(!(adjX>=0 && adjX<sx && adjY>=0 && adjY<sy) ) tt=false;
            else if(!G(adjX,adjY).selected) tt=false;
          }
          if(tt) G(i,j).V[k][2]=G(i,j).tmpH[k]; 
        }

		generateFace();
}

void MMGrid::smoothSelectedX()
{
  // 1) si calcola il valor medio e lo si stora in una var temporanea G(i,j).tmpH[k]
	int bp[4][2]={{ 0, 0},{ 1, 0},{1,1},{ 0,1}}; // base position of each vertex of the cell
	int dp[4][2]={{-1, -1},{ 0, -1 },{0,0},{ -1, 0}}; // delta of the four adj of a cell vertex
	int i,j,k,q;
	int cnt;
	float tH;
	for(i=0;i<sx;++i)
		for(j=0;j<sy;++j)
			if(G(i,j).selected)
				for(k=0;k<4;++k) //for each cell vertex;
				{
					tH=0;
					cnt=0;
					for(q=0;q<4;++q) // foreach adj of a cell vertexe
						{ 
              int adjX=i+dp[k][0]+bp[q][0];
              int adjY=j;

							if(adjX>=0 && adjX<sx)// && adjY>=0 && adjY<sy) 
                {
                  tH+=G(adjX,adjY).avgH();
							    ++cnt;
               }
						}
					G(i,j).tmpH[k]=tH/cnt;
				}
 // 1) si aggiorna tutti vertici non di bordo
  for(i=0;i<sx;++i)
		for(j=0;j<sy;++j)
			if(G(i,j).selected)
				for(k=0;k<4;++k) 
        {
          bool tt=true;
	        for(q=0;q<4;++q)
          {
            int adjX=i+dp[k][0]+bp[q][0];
            int adjY=j;//+dp[k][1]+bp[q][1];
            if(!(adjX>=0 && adjX<sx && adjY>=0 && adjY<sy) ) tt=false;
            else if(!G(adjX,adjY).selected) tt=false;
          }
          if(tt) G(i,j).V[k][2]=G(i,j).tmpH[k];

        }

		generateFace();
}

void MMGrid::smoothSelectedY()
{
  // 1) si calcola il valor medio e lo si stora in una var temporanea G(i,j).tmpH[k]
	int bp[4][2]={{ 0, 0},{ 1, 0},{1,1},{ 0,1}}; // base position of each vertex of the cell
	int dp[4][2]={{-1, -1},{ 0, -1 },{0,0},{ -1, 0}}; // delta of the four adj of a cell vertex
	int i,j,k,q;
	int cnt;
	float tH;
	for(i=0;i<sx;++i)
		for(j=0;j<sy;++j)
			if(G(i,j).selected)
				for(k=0;k<4;++k) //for each cell vertex;
				{
					tH=0;
					cnt=0;
					for(q=0;q<4;++q) // foreach adj of a cell vertexe
						{ 
              int adjX=i;
              int adjY=j+dp[k][1]+bp[q][1];

							if(adjX>=0 && adjX<sx && adjY>=0 && adjY<sy) 
                {
                  tH+=G(adjX,adjY).avgH();
							    ++cnt;
               }
						}
					G(i,j).tmpH[k]=tH/cnt;
				}
 // 1) si aggiorna tutti vertici non di bordo
  for(i=0;i<sx;++i)
		for(j=0;j<sy;++j)
			if(G(i,j).selected)
				for(k=0;k<4;++k) 
        {
          bool tt=true;
	        for(q=0;q<4;++q)
          {
            int adjX=i;//+dp[k][0]+bp[q][0];
            int adjY=j+dp[k][1]+bp[q][1];
            if(!(adjX>=0 && adjX<sx && adjY>=0 && adjY<sy) ) tt=false;
            else if(!G(adjX,adjY).selected) tt=false;
          }
          if(tt) G(i,j).V[k][2]=G(i,j).tmpH[k]; 
        }

		generateFace();
}

void MMGrid::flattenSelected()
{
	// first step compute average height
	int i,j;
	int cnt=0;
	float avgH=0;
	for(i=0;i<sx;++i)
		for(j=0;j<sy;++j)
			if(G(i,j).selected)	{
				avgH+=G(i,j).avgH();
				++cnt;
			}
	avgH/=cnt;
	// second step apply the compute average height
	vector<MMCell>::iterator ii;
	for (ii=g.begin();ii!=g.end();++ii) 
		if((*ii).selected)			
			for(int k=0;k<4;++k) 
					(*ii).V[k][2]=avgH;

	generateFace();
}

void MMGrid::ramp()
{
	bool isfirst = true;
	int i,j,firsti,firstj,lasti,lastj;
	int cnt;
	float avgH1,avgH2;
	for(i=0;i<sx;++i) {
		for(j=0;j<sy;++j) {
			if(G(i,j).selected)	{
				if (isfirst) {
					firsti=i;firstj=j;
					lasti=i;lastj=j;
					isfirst=false;
				} else {
					lasti=i;lastj=j;
				}
			}
		}
	}
	if ((lasti-firsti)>(lastj-firstj)) {
		cnt=0;avgH1=0;
		for(j=firstj;j<=lastj;++j) {
			avgH1+=G(firsti,j).avgH();
			++cnt;
		}
		avgH1/=cnt;
		cnt=0;avgH2=0;
		for(j=firstj;j<=lastj;++j) {
			avgH2+=G(lasti,j).avgH();
			++cnt;
		}
		avgH2/=cnt;
		for(j=firstj;j<=lastj;++j) {
			for (i=firsti;i<=lasti;++i) {

				G(i,j).V[0][2]=avgH1+(avgH2-avgH1)*((i-firsti+0.0f)/(lasti-firsti+1.0f));
				G(i,j).V[3][2]=avgH1+(avgH2-avgH1)*((i-firsti+0.0f)/(lasti-firsti+1.0f));
				G(i,j).V[1][2]=avgH1+(avgH2-avgH1)*((i-firsti+1.0f)/(lasti-firsti+1.0f));
				G(i,j).V[2][2]=avgH1+(avgH2-avgH1)*((i-firsti+1.0f)/(lasti-firsti+1.0f));
			}
		}
	} else {
		cnt=0;avgH1=0;
		for(i=firsti;i<=lasti;++i) {
			avgH1+=G(i,firstj).avgH();
			++cnt;
		}
		avgH1/=cnt;
		cnt=0;avgH2=0;
		for(i=firsti;i<=lasti;++i) {
			avgH2+=G(i,lastj).avgH();
			++cnt;
		}
		avgH2/=cnt;
		for(j=firstj;j<=lastj;++j) {
			for (i=firsti;i<=lasti;++i) {

				G(i,j).V[0][2]=avgH1+(avgH2-avgH1)*((j-firstj+0.0f)/(lastj-firstj+1.0f));
				G(i,j).V[1][2]=avgH1+(avgH2-avgH1)*((j-firstj+0.0f)/(lastj-firstj+1.0f));
				G(i,j).V[2][2]=avgH1+(avgH2-avgH1)*((j-firstj+1.0f)/(lastj-firstj+1.0f));
				G(i,j).V[3][2]=avgH1+(avgH2-avgH1)*((j-firstj+1.0f)/(lastj-firstj+1.0f));
			}
		}
	}

	generateFace();
}


/*
		for(j=firstj;j<=lastj;++j) {
			for(int k=0;k<4;++k) 
					G(firsti,j).V[k][2]=avgH1;
		}
		avgH2/=cnt;
		for(j=firstj;j<=lastj;++j) {
			for(int k=0;k<4;++k) 
					G(lasti,j).V[k][2]=avgH2;
		}
	}
}
*/
void MMGrid::valley()
{
	float offset = 1.0f;

	bool isfirst = true;
	int i,j,firsti,firstj,lasti,lastj;
	int cnt;
	for(i=0;i<sx;++i) {
		for(j=0;j<sy;++j) {
			if(G(i,j).selected)	{
				if (isfirst) {
					firsti=i;firstj=j;
					lasti=i;lastj=j;
					isfirst=false;
				} else {
					lasti=i;lastj=j;
				}
			}
		}
	}

 
        

	if ((lasti-firsti)>(lastj-firstj)) {
		cnt=0;
		for(j=firstj;j<lastj;++j) {
			for (i=firsti;i<lasti;++i) {
				G(i,j).V[2][2]=G(i,j).V[2][2]-offset*(float)((i-firsti+0.0f)/(lasti-firsti+0.0f))-offset*(float)((lasti-i+0.0f)/(lasti-firsti+0.0f));
			}
		}
		for(j=firstj+1;j<=lastj;++j) {
			for (i=firsti+1;i<=lasti;++i) {
				G(i,j).V[0][2]=G(i,j).V[0][2]-offset*(float)((i-firsti+0.0f)/(lasti-firsti+0.0f))-offset*(float)((lasti-i+0.0f)/(lasti-firsti+0.0f));
			}

		}
	} else {
		cnt=0;
		for(j=firstj;j<lastj;++j) {
			for (i=firsti;i<lasti;++i) {
				G(i,j).V[2][2]=G(i,j).V[2][2]-offset*(float)((j-firstj+0.0f)/(lastj-firstj+0.0f))-offset*(float)((lastj-j+0.0f)/(lastj-firstj+0.0f));
			}
		}
		for(j=firstj+1;j<=lastj;++j) {
			for (i=firsti+1;i<=lasti;++i) {
				G(i,j).V[0][2]=G(i,j).V[0][2]-offset*(float)((j-firstj+0.0f)/(lastj-firstj+0.0f))-offset*(float)((lastj-j+0.0f)/(lastj-firstj+0.0f));
			}
		}
	}
	smoothSelected();
	generateFace();
}
			







void MMGrid::setBallOnSelectionCenter()
{
	vector<MMCell>::iterator ii;
	for (ii=g.begin();ii!=g.end();++ii) 
		if((*ii).selected)			
		{
			sp.p=((*ii).V[0]+(*ii).V[1]+(*ii).V[2]+(*ii).V[3])/4.0;
			sp.p[2]+=3;
      sp.v=Point3f(0,0,0);
			return;
		}
   sp.p=G(sx/2,sy/2).V[0]+Point3f(0.5,0.5,0);
   sp.p[2]+=3;
   sp.v=Point3f(0,0,0);
}

void MMGrid::setBallOnStart()
{
   sp.p=start.p;
   sp.p[2]+=3;
   sp.v=Point3f(0,0,0);
}

void MMGrid::setStartOnSelectionCenter()
{
	vector<MMCell>::iterator ii;
	for (ii=g.begin();ii!=g.end();++ii) 
		if((*ii).selected)
		{
			start.p=((*ii).V[0]+(*ii).V[1]+(*ii).V[2]+(*ii).V[3])/4.0;
		}
}

void MMGrid::setFinishOnSelectionCenter()
{
	vector<MMCell>::iterator ii;
	int cococ=0;
	for (ii=g.begin();ii!=g.end();++ii) {
		if((*ii).selected)
		{
			finishgrid[cococ]=true;
			//finish.p=((*ii).V[0]+(*ii).V[1]+(*ii).V[2]+(*ii).V[3])/4.0;
			(*ii).finish=true;
		}
		cococ++;
	}
}

void MMGrid::setBumperOnSelection()
{
	vector<MMCell>::iterator ii;
	bool isfirst=true;
	for (ii=g.begin();ii!=g.end();++ii) 
		if((*ii).selected)
		{
			if (isfirst) {
                bumper.begin=((*ii).V[0]+(*ii).V[1]+(*ii).V[2]+(*ii).V[3])/4.0;
				bumper.end=((*ii).V[0]+(*ii).V[1]+(*ii).V[2]+(*ii).V[3])/4.0;
				bumper.begin[2]+=bumper.rad;
				bumper.end[2]+=bumper.rad;
				isfirst=false;
			} else {
				bumper.end=((*ii).V[0]+(*ii).V[1]+(*ii).V[2]+(*ii).V[3])/4.0;
				bumper.end[2]+=bumper.rad;
			}
		}
	bumper.exist = true;
}

void MMGrid::setBumperResping(int i) {
	bumper.resping=i;
}

void MMFace::ComputeE()
	{	
	  flags=0;
			// Primo calcolo degli edges
		edge[0] = (*(v[1])); edge[0] -= (*(v[0]));
		edge[1] = (*(v[2])); edge[1] -= (*(v[1]));
		edge[2] = (*(v[0])); edge[2] -= (*(v[2]));
			// Calcolo di plane
		plane.n = edge[0]^edge[1];
		plane.d = plane.n * (*(v[0]));
		plane.Normalize();
    n=plane.n;
			// Calcolo migliore proiezione
		float nx = Abs(plane.n[0]);
		float ny = Abs(plane.n[1]);
		float nz = Abs(plane.n[2]);
		float d;
		if(nx>ny && nx>nz) { flags |= NORMX; d = 1/plane.n[0]; }
		else if(ny>nz)     { flags |= NORMY; d = 1/plane.n[1]; }
		else               { flags |= NORMZ; d = 1/plane.n[2]; }

			// Scalatura spigoli
		edge[0] *= d;
		edge[1] *= d;
		edge[2] *= d;
	}

bool MMFace::Dist( const Point3f & q, float & dist, Point3f & p )
	{
		const float EPSILON = float(- 0.000001);
		float b;
			// Calcolo distanza punto piano
		float d = Distance( plane, q );
		if( d>dist || d<-dist )			// Risultato peggiore: niente di fatto
			return false;

			// Calcolo del punto sul piano
		// NOTA: aggiunto un '-d' in fondo Paolo C.
		Point3f t = plane.n;
		t[0] *= -d;
		t[1] *= -d;
		t[2] *= -d;
		p = q; p += t;
		
	#define PP(i)	(*(v[i]))
	#define E(i)    (edge[i])
    
		switch( flags & (NORMX|NORMY|NORMZ) )
		{
		case NORMX:
			b = E(1)[1]*(p[2] - PP(1)[2]) - E(1)[2]*(p[1] - PP(1)[1]);
			if(b<-EPSILON)
			{
				b = PSDist(q,(*(v[1])),(*(v[2])),p);
				if(dist>b) { dist = b; return true; }
				else return false;
			}
			b = E(2)[1]*(p[2] - PP(2)[2]) - E(2)[2]*(p[1] - PP(2)[1]);
			if(b<-EPSILON)
			{
				b = PSDist(q,(*(v[2])),(*(v[0])),p);
				if(dist>b) { dist = b; return true; }
				else return false;
			}
			b = E(0)[1]*(p[2] - PP(0)[2]) - E(0)[2]*(p[1] - PP(0)[1]);
			if(b<-EPSILON)
			{
				b = PSDist(q,(*(v[0])),(*(v[1])),p);
				if(dist>b) { dist = b; return true; }
				else return false;
			}
			break;

		  case NORMY:
			b = E(1)[2]*(p[0] - PP(1)[0]) - E(1)[0]*(p[2] - PP(1)[2]);
			if(b<-EPSILON)
			{
				b = PSDist(q,(*(v[1])),(*(v[2])),p);
				if(dist>b) { dist = b; return true; }
				else return false;
			}
			b = E(2)[2]*(p[0] - PP(2)[0]) - E(2)[0]*(p[2] - PP(2)[2]);
			if(b<-EPSILON)
			{
				b = PSDist(q,(*(v[2])),(*(v[0])),p);
				if(dist>b) { dist = b; return true; }
				else return false;
			}
			b = E(0)[2]*(p[0] - PP(0)[0]) - E(0)[0]*(p[2] - PP(0)[2]);
			if(b<-EPSILON)
			{
				b = PSDist(q,(*(v[0])),(*(v[1])),p);
				if(dist>b) { dist = b; return true; }
				else return false;
			}
			break;

		  case NORMZ:
			b = E(1)[0]*(p[1] - PP(1)[1]) - E(1)[1]*(p[0] - PP(1)[0]);
			if(b<-EPSILON)
			{
				b = PSDist(q,(*(v[1])),(*(v[2])),p);
				if(dist>b) { dist = b; return true; }
				else return false;
			}
			b = E(2)[0]*(p[1] - PP(2)[1]) - E(2)[1]*(p[0] - PP(2)[0]);
			if(b<-EPSILON)
			{
				b = PSDist(q,(*(v[2])),(*(v[0])),p);
				if(dist>b) { dist = b; return true; }
				else return false;
			}
			b = E(0)[0]*(p[1] - PP(0)[1]) - E(0)[1]*(p[0] - PP(0)[0]);
			if(b<-EPSILON)
			{
				b = PSDist(q,(*(v[0])),(*(v[1])),p);
				if(dist>b) { dist = b; return true; }
				else return false;
			}
			break;
		}

	#undef E
	#undef PP

		dist = fabs(d);
		//dist = Distance(p,q);
		return true;
	}



/*void MMGrid::generateFace()
{
	vector<MMCell>::iterator ii;
	for (ii=g.begin();ii!=g.end();++ii) 
		(*ii).generateFace();	
}*/

void MMGrid::generateFace()
{
	int i, j;
	for (i=0;i<sx;++i) {
		for (j=0;j<sy;++j) {
			/*G(i,j).ComputeNormal();
			G(i,j).face.clear();*/
			/*if ((j<sy-1)&&(i>0)) {
				G(i,j).B[0]=Point3f(G(i,j).V[0][0],G(i,j+1).V[3][2],G(i-1,j).V[1][2]);
			} else {
				G(i,j).B[0]=Point3f(G(i,j).V[0][0],G(i,j).V[0][1],0);
			}*/
			/*G(i,j).B[0]=Point3f(G(i,j).V[0][0],G(i,j).V[0][1],0);
			G(i,j).B[1]=Point3f(G(i,j).V[1][0],G(i,j).V[1][1],0);
			G(i,j).B[2]=Point3f(G(i,j).V[2][0],G(i,j).V[2][1],0);
			G(i,j).B[3]=Point3f(G(i,j).V[3][0],G(i,j).V[3][1],0);*/
			if (j>0) {
				G(i,j).B1[0]=G(i,j-1).V[3][2];
				G(i,j).B2[1]=G(i,j-1).V[2][2];
				G(i,j).B3[0]=true;
				if ((G(i,j).V[0][2] <= G(i,j-1).V[3][2]) && (G(i,j).V[1][2] <= G(i,j-1).V[2][2])) G(i,j).B3[0]=false;
			} else {
				G(i,j).B1[0]=G(i,j).V[0][2];
				G(i,j).B2[1]=G(i,j).V[1][2];
				G(i,j).B3[0]=true;
			}

			if (i<sx-1) {
				G(i,j).B1[1]=G(i+1,j).V[0][2];
				G(i,j).B2[2]=G(i+1,j).V[3][2];
				G(i,j).B3[1]=true;
				if ((G(i,j).V[1][2] <= G(i+1,j).V[0][2]) && (G(i,j).V[2][2] <= G(i+1,j).V[3][2])) G(i,j).B3[1]=false;
			} else {
				G(i,j).B1[1]=G(i,j).V[1][2];
				G(i,j).B2[2]=G(i,j).V[2][2];
				G(i,j).B3[1]=true;
			}

			if (j<sy-1) {
				G(i,j).B1[2]=G(i,j+1).V[1][2];
				G(i,j).B2[3]=G(i,j+1).V[0][2];
				G(i,j).B3[2]=true;
				if ((G(i,j).V[2][2] <= G(i,j+1).V[1][2]) && (G(i,j).V[3][2] <= G(i,j+1).V[0][2])) G(i,j).B3[2]=false;
			} else {
				G(i,j).B1[2]=G(i,j).V[2][2];
				G(i,j).B2[3]=G(i,j).V[3][2];
				G(i,j).B3[2]=true;
			}

			if (i>0) {
				G(i,j).B1[3]=G(i-1,j).V[2][2];
				G(i,j).B2[0]=G(i-1,j).V[1][2];
				G(i,j).B3[3]=true;
				if ((G(i,j).V[3][2] <= G(i-1,j).V[2][2]) && (G(i,j).V[0][2] <= G(i-1,j).V[1][2])) G(i,j).B3[3]=false;
			} else {
				G(i,j).B1[3]=G(i,j).V[3][2];
				G(i,j).B2[0]=G(i,j).V[0][2];
				G(i,j).B3[3]=true;
			}







			/*if (j<sy-1) {
				G(i,j).B[1]=Point3f(G(i,j).V[1][0],G(i,j).V[1][1],G(i,j+1).V[2][2]);
			} else {
				G(i,j).B[1]=Point3f(G(i,j).V[1][0],G(i,j).V[1][1],0);
			}
			if (i<sx-1) {
				G(i,j).B[2]=Point3f(G(i,j).V[2][0],G(i,j).V[2][1],G(i+1,j).V[3][2]);
			} else {
				G(i,j).B[2]=Point3f(G(i,j).V[2][0],G(i,j).V[2][1],0);
			}
			if (j>0) {
				G(i,j).B[3]=Point3f(G(i,j).V[0][0],G(i,j).V[0][1],G(i,j-1).V[0][2]);
			} else {
				G(i,j).B[3]=Point3f(G(i,j).V[0][0],G(i,j).V[0][1],0);
			}*/
			G(i,j).generateFace();
		}
	}
}

// Generate Face and cell
// si genera un insieme di vertici minimo
void MMCell::generateFace()
{ 
  ComputeNormal();
  face.clear();
	int k;
	for(k=0;k<4;++k) B[k]=Point3f(V[k][0],V[k][1],-10000);

	face.push_back(MMFace(&(V[0]),&(V[1]),&(V[2])));
	face.push_back(MMFace(&(V[0]),&(V[2]),&(V[3])));

	if(fabs(V[0][2]-B[0][2])>0.01) face.push_back(MMFace(&(V[0]),&(B[0]),&(V[1])));
	if(fabs(V[1][2]-B[1][2])>0.01) face.push_back(MMFace(&(V[1]),&(B[0]),&(B[1])));
	if(fabs(V[1][2]-B[1][2])>0.01) face.push_back(MMFace(&(V[1]),&(B[1]),&(V[2])));
	if(fabs(V[2][2]-B[2][2])>0.01) face.push_back(MMFace(&(V[2]),&(B[1]),&(B[2])));
	if(fabs(V[2][2]-B[2][2])>0.01) face.push_back(MMFace(&(V[2]),&(B[2]),&(V[3])));
	if(fabs(V[3][2]-B[3][2])>0.01) face.push_back(MMFace(&(V[3]),&(B[2]),&(B[3])));
	if(fabs(V[3][2]-B[3][2])>0.01) face.push_back(MMFace(&(V[3]),&(B[3]),&(V[0])));
	if(fabs(V[0][2]-B[0][2])>0.01) face.push_back(MMFace(&(V[0]),&(B[3]),&(B[0])));
	qDebug("Generate %i faces\n",face.size());
	
}
	
void MMCell::XMLWrite(QTextStream &xstrm)
{
	xstrm << V[0][2] << " " << V[1][2] << " " << V[2][2] << " " << V[3][2] /*<< " " << B1[0] << " " << B2[0] << " " << B1[1] << " " << B2[1] << " " << B1[2] << " " << B2[2] << " " << B1[3] << " " << B2[3]*/<< " " << texFileName << " " << ice << " " << glue << " " << finish << " \n";
}	

bool MMCell::XMLRead(QTextStream &xstrm)
{
	xstrm >> V[0][2] >>  V[1][2] >> V[2][2] >> V[3][2]/* >> B1[0] >> B2[0] >> B1[1] >> B2[1] >> B1[2] >> B2[2] >> B1[3] >> B2[3]*/ >> texFileName >> ice >> glue >> finish;
	return true;
}	

MMFace::MMFace(Point3f * v0, Point3f * v1, Point3f * v2)
{
	v[0]=v0;
	v[1]=v1;
	v[2]=v2;
	ComputeE();
}

void MMStart::drawGL()
{
	glPushMatrix();
	glTranslate(p);
	GLUquadricObj *qobj=gluNewQuadric();
	glColor3f(1,0,0);
	gluSphere(qobj,rad,12,6);
	glPopMatrix();
}

void MMBumper::drawGL()
{
	if(exist) {
		glPushMatrix();

		GLUquadricObj *qobj=gluNewQuadric();
		glColor3f(1,0,0);
		glTranslate(begin);

		//glRotatef(angxy,0,0,1);


		float distxy=sqrtf((begin[0]-end[0])*(begin[0]-end[0])+(begin[1]-end[1])*(begin[1]-end[1]));
		float angxy=(acosf((end[0]-begin[0])/distxy)*180.0f/M_PI)-90;

		//float distz=sqrtf((begin[2]-end[2])*(begin[2]-end[2])+(distxy*distxy));
		//float distz=sqrtf((begin[2]-end[2])*(begin[2]-end[2])+(distxy)*(distxy));
		float distz=Distance(begin,end);
		float angz;
		if (begin[2]<end[2]) {
            angz=-90+(acosf(distxy/distz)*180.0f/M_PI);
		} else {
			angz=-90-(acosf(distxy/distz)*180.0f/M_PI);
		}

		//glRotatef(angz,0,1,0);
		glRotatef(angxy,0,0,1);
		//glRotatef(-90,1,0,0);
		glRotatef(angz,1,0,0);

		gluCylinder(qobj,rad,rad,Distance(begin,end),12,6);
		
		glPopMatrix();
	}
	
}

bool MMBumper::collideSphere(MMSphere *s, Point3f &impact, Point3f &normal, float &mindist)
{

	Point3f P,P0,P1,v,w,Pb;
	float dist,b,c1,c2;


	P=s->p;
	P0=begin;
	P1=end;

	v=P1-P0;
	w=P-P0;
	c1=w*v;
	if (c1 <= 0) {
		dist = Distance(P,P0);
		impact = P0;
	} else {
		c2=v*v;
		if (c2 <= c1) {
			dist = Distance(P,P1);
			impact = P1;
		} else {
			b=c1/c2;
			Pb=P0+v*b;
			dist = Distance(P,Pb);
			impact=Pb;
		}
	}
	
	dist=fabs(dist);

	if ( dist <= (rad+(s->rad))) {
		normal = (s->p - impact);
		normal.Normalize();
		return true;
	}
	else
		return false;

}
/*
void MMFinish::drawGL()
{
	glPushMatrix();
	glTranslate(p);
	GLUquadricObj *qobj=gluNewQuadric();
	glColor3f(0,1,0);
	gluSphere(qobj,rad,12,6);
	glPopMatrix();
}
*/
/********** CISGGround *************/	
void MMSphere::drawGL() {

	if(!dl) {
		dl=glGenLists(1);
		glNewList(dl,GL_COMPILE);
		//glTexGeni(GL_S, GL_TEXTURE_GEN_MODE, GL_SPHERE_MAP);
		//glTexGeni(GL_T, GL_TEXTURE_GEN_MODE, GL_SPHERE_MAP);
		//glEnable(GL_TEXTURE_GEN_S);
		//glEnable(GL_TEXTURE_GEN_T);
		GLUquadricObj *qobj=gluNewQuadric();
		gluQuadricNormals(qobj,GLU_SMOOTH);
		gluQuadricTexture(qobj,GL_TRUE);
		gluSphere(qobj,rad,12,6);
		//glDisable(GL_TEXTURE_GEN_S);
		//glDisable(GL_TEXTURE_GEN_T);
		glEndList();
    }
	glPushMatrix();
	glTranslate(p);
	float tonorm=sqrt(v[0]*v[0]+v[1]*v[1]);
	rotangle+=v.Norm()*0.3f;
	if ((tonorm!=0)&&(!pause)) { 
        glRotatef(rotangle,-v[1]/tonorm,+v[0]/tonorm,0);
	}
	glCallList(dl);
	glPopMatrix();
}

void MMGrid::updateSpherePos(float docTime) {
	static float lastTime=0;
	if(!lastTime) lastTime=docTime;
	float dt=docTime-lastTime;
	lastTime=docTime;
	float tot=0;
	const float miniDt=0.010; 
	static bool colliding=false;
	bool collision=false;
	if (!pause) {
	while (tot < dt && !collision) {
		tot+=miniDt;
		sp.a=Point3f(0,0,-0.98f)*3;
		sp.a+=sp.a2;
		sp.a2/=2.0f;
		sp.v = sp.v+ sp.a*miniDt;
		
	/*	if(glue) {
			sp.v[0]=sp.v[0]*0.7;
			sp.v[1]=sp.v[1]*0.7;
		}
		*/
		sp.p=sp.p+sp.v*miniDt;

		vector<MMCell>::iterator ii;
		Point3f bestpt, pt;
		Point3f bestnt, nt;
		float mindist=10000;
		bool found=false; 
		bool foundglue=false;
		bool foundice=false;
    
		for (ii=g.begin();ii!=g.end();++ii) {
            if( (*ii).collideSphere(&sp,pt,nt, mindist) ) {
                bestpt=pt;
				bestnt=nt;
				found=true;
				foundglue=(*ii).glue;
				foundice=(*ii).ice;
				win = (*ii).finish;
			}
		}
		bool foundBumper=false;
		if (bumper.exist) {
            foundBumper = bumper.collideSphere(&sp,pt,nt, mindist);
		}
		float vel;
		if(found) {
			sp.p=bestpt+bestnt*sp.rad;
			 vel =0;
			vel= sp.v*bestnt;
			sp.v= sp.v - bestnt*(2.0f*vel*.7);


			if(sp.v.Norm() <0.01) sp.v.Zero();
			//break;
		}
		if(foundBumper) {

			sp.p=pt+nt*(bumper.rad+sp.rad);
			float vel2 =0;
			vel= sp.v*nt;
			//vel=(vel+vel2)/2.0f;
			sp.v= sp.v - nt*(2.0f*vel*bumper.resping/80);

			if(sp.v.Norm() <0.01) sp.v.Zero();
			
		}
		if (foundglue) {
		    sp.v[0]=sp.v[0]*0.95f;
			sp.v[1]=sp.v[1]*0.95f;
		}
		if (foundice) {
			sp.a2[0]=sp.a2[0]/10.0f;
			sp.a2[1]=sp.a2[1]/10.0f;
		}
	}}
}



bool MMCell::collideSphere(MMSphere *s, Point3f &impact, Point3f &normal, float &mindist)
{
	impact.Zero();
  normal.Zero();
  
  bool found=false;
  for(int i=0;i<face.size();++i)
	{
		float dist=mindist;
		Point3f closest;
		bool fnd=face[i].Dist(s->p,dist,closest);
		if(fnd && fabs(dist)<s->rad) 
		{
			dist=fabs(dist);
			impact=closest;
			if(dist<mindist) mindist=dist;
			normal=(s->p-closest);
		 //	qDebug("impact %f %f %f\n",impact[0],impact[1],impact[2]);
			found=true;
		}
	}
  normal.Normalize();
  return found;
}

void MMGrid::moveSphere(float x,float y) {

	sp.a2[0]+=x;
	sp.a2[1]+=y;


}

Point3f MMGrid::getSpherePosition() {
	return sp.p;
}

Point3f MMGrid::getSphereMovement() {
	return sp.v;
}

float MMGrid::checkFall() {
	return sp.v[2];
}